#include "stdafx.h"

#include "syncmgr.h"
#include "hslog.h"
#include "condapi.h"

#ifndef ExportFunc
#define ExportFunc __declspec( dllexport )
#endif

#include "basemon.h"
#include "condmgre.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

#endif /*  */
HINSTANCE myInst = 0;

class CBoxcondDll:public CWinApp { public:
   virtual BOOL InitInstance(); // Initialization
  virtual int ExitInstance();   // Termination 

    DECLARE_MESSAGE_MAP();
};

BEGIN_MESSAGE_MAP(CBoxcondDll, CWinApp)
  END_MESSAGE_MAP();

     BOOL CBoxcondDll::InitInstance()
{
  TRACE0("BOXRCOND.DLL initializing\n");
  myInst = AfxGetInstanceHandle();
  return TRUE;
}

int CBoxcondDll::ExitInstance()
{
  TRACE0("BOXRCOND.DLL Terminating!\n");
  return CWinApp::ExitInstance();
}

CBoxcondDll boxcondDll;

ExportFunc long OpenConduit(PROGRESSFN pFn, CSyncProperties & rProps)
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());
  long retval = 0;
  byte hRemoteDatabase = 0;
  byte whichway = 0;
  int i;
  CFile localFile;
  CString localFileName;
  CONDHANDLE conduitHandle = (CONDHANDLE) 0;
  CRawRecordInfo rawRecord;

  // Register this conduit with SyncMgrDLL for communication to HH
  if (retval = SyncRegisterConduit(conduitHandle))
    return (retval);

  switch (rProps.m_SyncType) {
  case eFast:
  case eSlow:
    whichway = 3;
    break;
  case eInstall:
  case ePCtoHH:
    whichway = 2;
    break;
  case eBackup:
  case eHHtoPC:
    whichway = 1;
    break;
  default:
    break;
  }

  if (whichway & 1) {
    for (i = 0; i < rProps.m_nRemoteCount; i++) {
      SyncOpenDB(rProps.m_RemoteName[i], 0, hRemoteDatabase);

      // store file by dbname in the Unboxer directory 
      localFileName = rProps.m_PathName;
      localFileName += rProps.m_RemoteName[i];

      retval =
        !(localFile.
          Open(LPCTSTR(localFileName), CFile::modeCreate | CFile::modeWrite));
      if (retval || localFile.m_hFile == CFile::hFileNull) {
        SyncUnRegisterConduit(conduitHandle);
        return (retval);
      }

      memset(&rawRecord, 0, sizeof(CRawRecordInfo));
      rawRecord.m_FileHandle = hRemoteDatabase;
      rawRecord.m_pBytes = (BYTE *) new char[4800];
      if (rawRecord.m_pBytes) {
        rawRecord.m_TotalBytes = 4800;
        memset(rawRecord.m_pBytes, 0, 4800);
      }

      while (!(retval = SyncReadRecordByIndex(rawRecord))) {
        localFile.Write(&rawRecord.m_pBytes[8], rawRecord.m_RecSize - 8);
        rawRecord.m_RecIndex++;
      }

      localFile.Close();
      SyncCloseDB(hRemoteDatabase);

      if (retval == SYNCERR_FILE_NOT_FOUND)
        retval = 0;

      strcpy((char *) rawRecord.m_pBytes, "UnBoxed: ");
      strcat((char *) rawRecord.m_pBytes, LPCTSTR(localFileName));
      LogAddEntry((const char *) rawRecord.m_pBytes, slText, FALSE);

      delete rawRecord.m_pBytes;
    }

  }


  if (whichway & 2) {
#if 0

    FindFileName = rProps.m_PathName;
    FindFirstFile()l localFile.Close();
    remove(localFileName);

    strcpy((char *) rawRecord.m_pBytes, "Boxed: ");
    strcat((char *) rawRecord.m_pBytes, LPCTSTR(localFileName));
    LogAddEntry((const char *) rawRecord.m_pBytes, slText, FALSE);

    delete rawRecord.m_pBytes;


    SyncCloseDB(hRemoteDatabase);
#endif
  }


  SyncUnRegisterConduit(conduitHandle);
  return (retval);
}


ExportFunc long GetConduitName(char *pszName, WORD nLen)
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());
  long retval = 0;
  memset(pszName, 0, nLen);
  strncpy(pszName, "UnBoxer", nLen - 1);
  return retval;
}

ExportFunc DWORD GetConduitVersion()
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());
  return 5;
}

ExportFunc long GetConduitInfo(ConduitInfoEnum infoType, void *pInArgs,
                               void *pOut, DWORD * pdwOutSize)
{
  AFX_MANAGE_STATE(AfxGetStaticModuleState());
  if (!pOut)
    return CONDERR_INVALID_PTR;
  if (!pdwOutSize)
    return CONDERR_INVALID_OUTSIZE_PTR;
  switch (infoType) {
  case eConduitName:

    // This code is for example. This conduit does not use this code
    if (!pInArgs)
      return CONDERR_INVALID_INARGS_PTR;

    ConduitRequestInfoType *pInfo;

    pInfo = (ConduitRequestInfoType *) pInArgs;

    if ((pInfo->dwVersion != CONDUITREQUESTINFO_VERSION_1) ||
        (pInfo->dwSize != SZ_CONDUITREQUESTINFO))
        return CONDERR_INVALID_INARGS_STRUCT;

    memset((TCHAR *) pOut, 0, *pdwOutSize);
    strncpy((TCHAR *) pOut, "UnBoxer", (*pdwOutSize) - 1);
    break;

  case eDefaultAction:
    if (*pdwOutSize != sizeof(eSyncTypes))
      return CONDERR_INVALID_BUFFER_SIZE;
    (*(eSyncTypes *) pOut) = eFast;
    break;

  default:
    return CONDERR_UNSUPPORTED_CONDUITINFO_ENUM;
  }
  return 0;
}
